# Copyright 2021 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import fields, models, api


class ResPartner(models.Model):
    _inherit = "res.partner"

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------
    is_pmo = fields.Boolean("Est un PMO")
    acc_operation_ids = fields.One2many(
        comodel_name="acc.operation",
        inverse_name="pmo_id",
        string="Liste des opérations",
    )
    is_acc_linked = fields.Boolean("Est un sociétaire/adhérent/actionnaire app")
    is_producer = fields.Boolean("Est un producteur")
    is_consumer = fields.Boolean("Est un consommateur")
    is_buyer_surplus = fields.Boolean("Est un acheteur de surplus")
    injection_counter_ids = fields.One2many(
        comodel_name="acc.counter",
        inverse_name="partner_id",
        string="Liste des points d'injection",
        domain="[('is_injection', '=', True)]",
    )
    delivery_counter_ids = fields.One2many(
        comodel_name="acc.counter",
        inverse_name="partner_id",
        string="Liste des points d'injection",
        domain="[('is_delivery', '=', True)]",
    )
    mail_contact_pmo = fields.Char("Mail du contact PMO")
    date_log = fields.Datetime("Date de connexion")
    ref_producer = fields.Char("Référence du producteur")
    origine = fields.Selection([
        ("pv", "pv"),
        ("eo", "éo"),
        ("hyd", "hyd"),
    ], string="Origine")
    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------
    @api.model
    def create(self, vals):
        if vals.get("is_producer") == True:
            vals["ref_producer"] = self.env["ir.sequence"].next_by_code("res.partner")
        result = super(ResPartner, self).create(vals)
        return result
    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
